---
AWSTemplateFormatVersion: "2010-09-09"
Description: Creates SQS for ECS Service(s)
Resources:
{% for queue, properties in queues.items() %}

  Queue{{ properties.queuename | capitalize | replace('-', '') | replace('.', '')  }}:
    Type: AWS::SQS::Queue
    Properties:
      QueueName: {{ properties.queuename }}
{% if ( properties.fifoqueue | default(False) ): %}
{% set fifoprops = properties.fifoq | default({}) %}
      FifoQueue: true
      ContentBasedDeduplication: {{ fifoprops.contentbaseddeduplication | default(False)}}
{% endif %}
      DelaySeconds: {{ properties.delayseconds | default(0) }}
      VisibilityTimeout: {{ properties.visibilitytimeout | default(30) }}
      MaximumMessageSize: {{ properties.maximummessagesize | default(262144) }}
      MessageRetentionPeriod: {{ properties.messageretentionperiod | default(345600) }}
{% if (properties.encrypt | default(False)): %}
      KmsMasterKeyId: {{ properties.kmsmasterkeyid }}
      KmsDataKeyReusePeriodSeconds: {{ properties.kmsdatakeyreuseperiodseconds | default(300) }}
{% endif %}
      Tags:
        - Key: "Name"
          Value: {{ properties.queuename }}
{% if (properties.deadletterqueue | default(False)): %}
      RedrivePolicy:
        deadLetterTargetArn:
          Fn::GetAtt:
            - DlQueue{{ properties.queuename | capitalize | replace('-', '') }}
            - "Arn"
        maxReceiveCount: {{ properties.maxreceivecount | default(10) }}

{% set dlqprops = properties.dlq | default({}) %}
  DlQueue{{ properties.queuename | capitalize | replace('-', '') | replace('.', '') }}:
    Type: AWS::SQS::Queue
    Properties:
      QueueName: "{{ properties.queuename }}-dlq"
{% if ( dlqprops.fifoqueue | default(properties.fifoqueue | default(False)) ): %}
      FifoQueue: true
{% endif %}
      DelaySeconds: {{ dlqprops.delayseconds | default(properties.delayseconds | default(0)) }}
      VisibilityTimeout: {{ dlqprops.visibilitytimeout | default(properties.visibilitytimeout | default(30)) }}
      MaximumMessageSize: {{ dlqprops.maximummessagesize | default(properties.maximummessagesize | default(262144)) }}
      MessageRetentionPeriod: {{ dlqprops.messageretentionperiod | default(1209600) }}
{% if (properties.encrypt | default(False)): %}
      KmsMasterKeyId: {{ properties.kmsmasterkeyid }}
      KmsDataKeyReusePeriodSeconds: {{ properties.kmsdatakeyreuseperiodseconds | default(300) }}
{% endif %}
      Tags:
        - Key: "Name"
          Value: "{{ properties.queuename }}-dlq"
{% endif %}
{% endfor %}
